package util;


/**
 * Models a deck of cards made up of n packs of 52 cards (with one or two Joker per pack optional).
 * Shuffled on initialization.
 */
public class Deck 
{
	/**
	 * Allowable number of Jokers per pack, between 0 and 2 inclusive.
	 */
	public enum NumberOfJokers
	{ ZERO, ONE, TWO }
	
	/**
	 * Allowable number of pack, between 1 and 2 inclusive.
	 */
	public enum NumberOfPacks
	{ ONE, TWO }
	
	/**
	 * Builds a deck with a specified number of packs and Jokers per pack.
	 * After this method the deck is shuffled.
	 * @param numberOfJokers The required number of Jokers per pack
	 * @param numberOfPacks The number of packs
	 */
	public Deck(NumberOfPacks numberOfPacks, NumberOfJokers numberOfJokers)
	{}
	
	/**
	 * Shuffle the deck of cards by restoring all the cards and randomizing
	 * their order.
	 */
	public void shuffle()
	{}
	
	/**
	 * Draws a card from the deck and removes the card from the deck.
	 * @return The card drawn.
	 * @post final.size() == initial.size() - 1 OR EmptyDeckException
	 * @throws EmptyDeckException if this method is called when size() == 0
	 */
	public Card draw() throws EmptyDeckException
	{}
	
	/**
	 * Returns the size of the deck.
	 * @return The number of cards in the deck.
	 */
	public int size()
	{}
}
